/* (C)opyrigth by Mauri Sahlberg 1990,1991,1992
   This file is distributed under following conditions:
   - You may freely copy and distribute this program as long as it
     is distributed in original form.
   - This header may not be modified and must not be removed.
   - No warranty is given. If this program nukes your machine, I plead
     not guilty. Any kind of damage this program does to your software,
     hardware or your person is on your own responsibility.
   - If you wish to include this program or its source as part of
     comercial package you should ask my permission to do so.
   - If you find this program usefull, you should at least send me a postcard.
     Feedback is always welcome. (You may also buy me beer :-)		
*/

/*
Program   : Rolechar-Developer v6.0
File      : stat.cc
Last edit : 10/20/92
Created   :
Version   : 1.14

History   :

Does      : Stat-class functions
*/
#include <stdlib.h>
#include <errno.h>
#include <curses.h>
#include <string.h>
#include <ctype.h>

#include <limits.h>
#include <paths.h>
#include <mcform.h>
 
#include "st_opt.h"
#include "st.h"
#include "type.h"
#include "stat.h"
#include "cc_protot.h"

/* Outputs stats. */
void role_stat::print()
{
  put_st(&st);
}

/* Quick generation. */
void role_stat::qgen(int m)
{
  FILE 	*src=NULL;
  int 	rajat[79]={0};
  int 	i=0;
  int 	arvo=0;
  int 	tulos=0;
  
  src = fopen(STATS,"r");
  if(!src) {
    perror("STATS");
    exit(0);
  }
  
  lvl = 0;
  for(i=0;i<78;i++) 
    fscanf(src,"%i",&rajat[i]);

  fclose(src);

  for(i=0;i<10;i++) {
    arvo = 0;
    tulos = sattuma(1,1000);
    while(tulos > rajat[arvo]) arvo++;
    arvo +=25;
    st.tmp[i] = arvo;
    st.pot[i] = arvo;
  }
  role_stat::statistics();
  role_stat::bonus(m);
  role_stat::print();
}

/* Normal generation. */
void role_stat::ngen(int m)
{
  int 	k=0;  
  FILE 	*src=NULL;
  int 	rajat[79]={0};
  int 	i=0;
  int 	arvo=0;
  int 	tulos=0;
  int 	yrajat[38];
  int 	xrajat[12];
  int 	result[38][12];
  int 	j=0;
  int 	roll=0;

  lvl = 0;
  src = fopen(STATS,"r");
  if(!src) {
    perror(STATS);
    exit(0);
  }
  
  for(i=0;i<78;i++) 
    fscanf(src,"%i",&rajat[i]);

  for(i=0;i<38;i++)
    fscanf(src,"%i",&yrajat[i]);

  for(i=0;i<12;i++)
    fscanf(src,"%i",&xrajat[i]);

  for(j=0;j<38;j++)
    for(i=0;i<12;i++)
      fscanf(src,"%i",&result[j][i]);

  fclose(src);

  for(k=0;k<10;k++) {
    arvo = 0;
    arvo = sattuma(25,100);
    if(arvo < 25) {
      printf("Error:\n"); 	
      break;
    }
    st.tmp[k] = arvo;    
    for(i=0;i<12;i++)
      if(arvo < xrajat[i]) break;
    j = 0;
    roll = sattuma(1,100);;	
    while(roll > yrajat[j]) j++;
    if(result[j][i] == 10)
      st.pot[k] = st.tmp[k];
    else
      st.pot[k] = result[j][i];
  }   
  role_stat::statistics(1);
  role_stat::bonus(m);
  role_stat::print();
}

/* the mos method. */
void role_stat::mgen(int m)
{
  int 	k=0;  
  FILE 	*src=NULL;
  int 	rajat[79];
  int 	i=0;
  int 	arvo=0;
  int 	tulos=0;
  int 	yrajat[38];
  int 	xrajat[12];
  int 	result[38][12];
  int 	j=0;
  int 	roll=0;

  lvl = 0;
  src = fopen(STATS,"r");
  if(!src) {
    perror("role_stat.cc/fopen");
    exit(0);
  }
  
  for(i=0;i<78;i++) 
    fscanf(src,"%i",&rajat[i]);

  for(i=0;i<38;i++)
    fscanf(src,"%i",&yrajat[i]);

  for(i=0;i<12;i++)
    fscanf(src,"%i",&xrajat[i]);

  for(j=0;j<38;j++)
    for(i=0;i<12;i++)
      fscanf(src,"%i",&result[j][i]);

  fclose(src);
  for(k=0;k<10;k++) {
    arvo = 0;
    tulos = sattuma(1,1000);
    while(tulos > rajat[arvo]) arvo++;
    arvo +=25;
    st.tmp[k] = arvo;

    for(i=0;i<12;i++)
      if(arvo < xrajat[i]) break;
    j = 0;
    roll = sattuma(1,100);;	
    while(roll > yrajat[j]) j++;
    if(result[j][i] == 10)
      st.pot[k] = st.tmp[k];
    else
      st.pot[k] = result[j][i];
  }   
  role_stat::statistics(1);
  role_stat::bonus(m);
  role_stat::print();
}

/* Stat raising. */
void role_stat::raise(int m)
{
  int 	k=0;  
  FILE 	*src=NULL;
  int 	rajat[189];
  int 	i=0;
  int 	arvo=0;
  int 	tulos=0;
  int 	yrajat[22];
  int 	xrajat[10];
  int 	j=0;
  int 	erotus=0;

  src = fopen(GAIN,"r");
  if(!src) {
    perror(GAIN);
    exit(0);
  }

    
  for(i=0;i<10;i++)
    fscanf(src,"%i",&xrajat[i]);

  for(i=0;i<22;i++)
    fscanf(src,"%i",&yrajat[i]);

  for(i=0;i<189;i++) 
    fscanf(src,"%i",&rajat[i]);

  fclose(src);
  for(k=0;k<10;k++) {
    arvo = 0;
    tulos = sattuma(1,100);
    if(m && tulos >= 96) st.pot[k]++;
    if(m && tulos >= 99) {
      st.tmp[k]++;
      st.pot[k]++;
    }
    if(tulos <= 4) {
      st.tmp[k]-= sattuma(2,8);
      continue;
    }
    erotus = st.pot[k]-st.tmp[k];
    if(erotus > 15) erotus = 15;
    if(!erotus) continue;
    i = 1;
    j = 0;
    while((i < 8) && (erotus > xrajat[i])) i++;
    while((j < 20) && (tulos  > yrajat[j])) j++;    
    
    i--;
    st.tmp[k] += rajat[i+9 * j];
    if(st.tmp[k] > st.pot[k]) {
      printf("Erotus: %i Rolli: %i X: %i Y: %i\n",erotus, tulos, i, j);
      exit(0);
    }
  }
  role_stat::count_totals();
}

/* Stat-bonuses. */
void role_stat::bonus(int  m)
{
  int 	i=0;
  int 	rajat[18]={  1,  2,  4,  9, 14,24,39,59,74,84,89,89,94,97,99,100,101};
  int 	bonus[18]={-25,-20,-15,-10,-5, -5, 0, 0, 0, 5, 5,10,15,20,25, 30,35};
  float tdevo[18]= {  1.0,  1.0,  1.0,  2.0, 2.0, 3.0, 4.0, 5.0, 6.0, 7.0, 8.0, 8.0, 9.0,  9.0, 10.0, 10.0,11.0};
  int	mrajat[42] ={1 , 2, 3, 4, 5, 6, 7, 8, 9,10,11,15,18,21,24,27,28,32,
                   36,40,59,63,67,71,74,77,80,83,86,89,90,91,92,93,94,95,96,
	           97,98,99,100};
  float	mdevo[42]={1.0,1.3,1.6,1.8,2.0,2.2,2.4,2.6,2.7,2.8,2.9,3.0,3.3,3.6,3.8,
		   4.0,4.3,4.6,4.8,5.0,5.5,6.0,6.3,6.6,6.8,7.0,7.4,7.7,8.0,8.2,
		   8.4,8.6,8.7,8.8,8.9,9.0,9.2,9.4,9.6,9.8,10.0};              
  int 	bonu=0;
  int 	j=0;

  for(i=0;i<10;i++) {
    if(st.tmp[i] > 100) {
      st.bon[i] = 25 + (st.tmp[i]-100)*5;
      st.dev[i] = 11.0;
      continue;
    } 
    if(!m) {
      j = 0;
      while((j<18) && (st.tmp[i] > rajat[j])) j++;
      st.bon[i] = bonus[j];
      st.dev[i] = tdevo[j];	
    }
    if(m == 1){      
      j = 0;
      while((j < 42) && (st.tmp[i] > mrajat[j])) j++;
      st.dev[i] = mdevo[j];
      st.bon[i] = -20 + j;
      if(j < 6 || j > 35) 
        switch(j) {
	  case 1:
	    st.bon[i] = -25;
	    break;
	  case 2:
	    st.bon[i] = -23;
	    break;
	  case 3:
	    st.bon[i] = -21;
	    break;
	  case 4:
	    st.bon[i] = -19;
	    break;
	  case 5:
	    st.bon[i] = -17;
	    break;
	  case 36:
	    st.bon[i] = 17;
	    break;
	  case 37:
	    st.bon[i] = 19;
	    break;
	  case 38:
	    st.bon[i] = 21;
	    break;
	  case 39:
	    st.bon[i] = 23;
	    break;
 	  case 40:
	    st.bon[i] = 25;
	    break;

        }
    }
    if(m == 2) {
      st.bon[i] = (st.tmp[i]-50) /2;
      st.dev[i] = (float)st.bon[i] / 10.0 * 4.0;
      if(st.dev[i] < 0) 
        st.dev[i] = 0;	
    }
  }
  role_stat::count_totals();
}	      

/* Statistics. */
void role_stat::statistics(int m)
{
  float value=0.0;
  int arvo=25;
  int tulos;
  int good=0;
  int bad=0;
  float index;
  int great=0;
  int i=0;
  int tst;

  for(i=0;i<10;i++) {
    tst = m ? st.pot[i] : st.tmp[i]; 
    value += tst / 10.0;	
    if(tst > 90) good++;
    if(tst < 40) bad++;	
    if(tst > 99) great++;
  }

  st.good = good;
  st.bad = bad;
  st.all = value;
  st.mos = (st.all / 10.0 + .50 * great + .50 * st.good - .50 * st.bad) * .42;

  return;
}

/* Racial bonus.*/
void role_stat::enter_racial(int i, int v)
{
  st.rac[i] = v;
  role_stat::count_totals();
}

/* Misc bonus. */
void role_stat::enter_misc(int i, int v)
{
  st.mis[i] = v;
  role_stat::count_totals();
}

/* Totals. */
void role_stat::count_totals()
{
  for(int i=0;i<10;i++) 
    st.tot[i] = st.bon[i] + st.rac[i]+st.mis[i];
}

/* Edit.*/
void role_stat::edit()
{
  struct st huuhaa;

  huuhaa = st;
  clear();
  refresh();

  put_st(&huuhaa);
  get_st(&huuhaa);
  st = huuhaa;
}

/* Raise. */
void role_stat::level(int ext, int level, int target)
{
   int i;
   char al[5];
   int t=0;

   lvl = level;
   if(lvl > target) {
     sprintf(al,"%i",lvl);
     move(20,0);
     printw("Your current level is: %i\n",lvl);
     move(21,0);
     printw("Enter new level:");
     refresh();

     i = get_integer(17,21,3,&t,0,al);   
     move(20,0);
     clrtoeol();
     move(21,0);
     clrtoeol();
     refresh();
   } else
    i = target;
  
   if(i <= lvl)
     return;
  
   for(;lvl < i;lvl++) 
     role_stat::raise(ext);
    
   role_stat::statistics();
   role_stat::bonus();
   clear();
   refresh();
   role_stat::print();
   move(22,1);
   printw("Press any key to continue!\n");
   refresh();
   getch();
   return;
}

/* Place */
void role_stat::place()
{
  int ok=0;
  char fr[4];
  char to[4];
  char al[4];
  char *a;
  int ko=0;
  char *b;
  char guh[10][3]={"CO","SD","AG","MQ","RE","ST","QU","PR","IN","EM"};
  int ai,bi;
  float f;
  int i;

  clear();
  refresh();
  put_st(&st);
  move(23,0);
  
  attron(A_BOLD);
  printw("Stat-WB (placement)\n");
  attroff(A_BOLD);
  refresh();
  while(!ok) {
    put_st(&st);	
    move(21,0);
    printw("From role_stat:    To role_stat:   ");
    move(22,0);
    printw("Enter -1 to end.");	
    refresh();
    a = get_string(16,21,3,&ko,0,NULL);
    b = get_string(33,21,3,&ko,0,NULL);
    if(!strcmp(a,"-1") || !strcmp(b,"-1")) 
      break;
    for(i=0;i<10;i++) 
      if(!strcmp(a,guh[i])) break;        
    ai = i;
    for(i=0;i<10;i++)
      if(!strcmp(b,guh[i])) break;
    bi = i;
    if(ai < 0 || ai >  9 || ai == bi)
      continue;
    if(bi < 0 || bi > 9)
      continue;
    i = st.tmp[ai];
    st.tmp[ai] = st.tmp[bi];
    st.tmp[bi] = i;
    i = st.pot[ai];
    st.pot[ai] = st.pot[bi];
    st.pot[bi] = i;
    i = st.bon[ai];
    st.bon[ai] = st.bon[bi];
    st.bon[bi] = i;
    i = st.rac[ai];
    st.rac[ai] = st.rac[bi];
    st.rac[bi] = i;
    i = st.mis[ai];
    st.mis[ai] = st.mis[bi];
    st.mis[bi] = i;
    i = st.tot[ai];
    st.tot[ai] = st.tot[bi];
    st.tot[bi] = i;
    f = st.dev[ai];
    st.dev[ai] = st.dev[bi];
    st.dev[bi] = f;
  }
}

/* Save */
void role_stat::save(char *name)
{
  FILE *dst;

  dst = fopen(name,"w");
  if(!dst) {
    move(22,0);
    clrtoeol();
    refresh();
    printw("Sorry, couldn't save role_stats. Press a key.\n");
    refresh();
    getch();
    move(22,0);
    clrtoeol();
    refresh();
    return;
  }
  putw(lvl,dst);
  fwrite(&st,sizeof(struct st),1,dst);
  fclose(dst);
  return;
}

/* Load */     
void role_stat::load(char *name)
{
  FILE *src=NULL;

  src = fopen(name,"r");
  if(!src) {
    move(22,0);
    clrtoeol();
    refresh();
    printw("Sorry, couldn't load role_stats. Press a key.\n");
    refresh();
    getch();
    move(22,0);
    clrtoeol();
    refresh();
    return;
  }
  
  lvl = getw(src);
  fread(&st,sizeof(struct st),1,src);
  fclose(src);
}

/* Raise one. */
void role_stat::raise_one(int stat, int amount)
{
  st.tmp[stat] += amount;
  st.pot[stat] += amount;
}

/* Primes. */
void role_stat::primes(char *prime)
{
  char *t;

  t = strtok(prime,"/\0");
  while(t) {
    if(!strcmp(t,"CO") && st.pot[0] < 90) { 
      st.pot[0] = 90;
      st.tmp[0] = 90;
    };
    if(!strcmp(t,"SD") && st.pot[1] < 90) { 
      st.pot[1] = 90;
      st.tmp[1] = 90;
    };
    if(!strcmp(t,"AG") && st.pot[2] < 90) { 
      st.pot[2] = 90;
      st.tmp[2] = 90;
    };
    if(!strcmp(t,"MQ") && st.pot[3] < 90) { 
      st.pot[3] = 90;
      st.tmp[3] = 90;
    };
    if(!strcmp(t,"RE") && st.pot[4] < 90) { 
      st.pot[4] = 90;
      st.tmp[4] = 90;
    };
    if(!strcmp(t,"ST") && st.pot[5] < 90) { 
      st.pot[5] = 90;
      st.tmp[5] = 90;
    };
    if(!strcmp(t,"QU") && st.pot[6] < 90) { 
      st.pot[6] = 90;
      st.tmp[6] = 90;
    };
    if(!strcmp(t,"PR") && st.pot[7] < 90) { 
      st.pot[7] = 90;
      st.tmp[7] = 90;
    };
    if(!strcmp(t,"IN") && st.pot[8] < 90) { 
      st.pot[8] = 90;
      st.tmp[8] = 90;
    };
    if(!strcmp(t,"EM") && st.pot[9] < 90) { 
      st.pot[9] = 90;
      st.tmp[9] = 90;
    };

    t = strtok(NULL,"/\0");
  }
}

/* Developmentpoints. */
float role_stat::calc_devo(int m)
{
  int i=0;
  float summa=0.0;

  if(!m) 
    for(i=0;i<5;i++)  
      summa += st.dev[i];

  return summa;
} 	

/* Total bonus. */
int role_stat::get_total(int m)
{
  return st.tot[m];
}

/* Temporary stat. */
int role_stat::get_tmp(int m)
{
  return st.tmp[m];
}

void role_stat::dump_stats(FILE *dst)
{
  char *snames[10]={"CO","SD","AG","MQ","RE","ST","QU","PR","IN","EM"};
  int i=0;

  fprintf(dst,"+------+-----+-----+-----+-----+-----+-----+-------+\n");
  fprintf(dst,"| STAT | TMP | POT | BON | RAC | MIS | TOT | DEV   |\n");
  fprintf(dst,"+------+-----+-----+-----+-----+-----+-----+-------+\n");
  for(i=0;i<10;i++)
    fprintf(dst,"|  %2s  | %3i | %3i | %3i | %3i | %3i | %3i | %5.2f |\n",
	     snames[i], st.tmp[i],st.pot[i], st.bon[i], st.rac[i],
             st.mis[i], st.tot[i], st.dev[i]);  
  fprintf(dst,"+------+-----+-----+-----+-----+-----+-----+-------+\n");
}
